<?xml version='1.0'?>
<!DOCTYPE stylesheet [
<!ENTITY copy  "&#169;" >
<!ENTITY nbsp "&#160;"> 
]>
<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:xs="http://www.w3.org/2001/XMLSchema"
                xmlns:date="http://exslt.org/dates-and-times"
                extension-element-prefixes="date" xmlns:camed="http://jcam.org.uk/editor" xmlns:as="http://www.oasis-open.org/committees/cam" exclude-result-prefixes="as camed look" xmlns:look="http://jcam.org.uk/LookupLists">
<!-- Changes
       07/26/09 drrw Correct uncast type for as:attribute attrCount parameter 
-->
 
 <!--<xsl:param name="date"><xsl:value-of select="date:year()"/><xsl:if test="date:month-in-year() &lt; 10">0</xsl:if><xsl:value-of select="date:month-in-year()"/><xsl:if test="date:day-in-month() &lt; 10">0</xsl:if><xsl:value-of select="date:day-in-month()"/><xsl:if test="date:hour-in-day() &lt; 10">0</xsl:if><xsl:value-of select="date:hour-in-day()"/><xsl:if test="date:minute-in-hour() &lt; 10">0</xsl:if><xsl:value-of select="date:minute-in-hour()"/></xsl:param>--><!--200707041350-->
 <xsl:param name="filename"><xsl:value-of select="if(string-length(/as:CAM/as:AssemblyStructure/as:Structure/@ID) &gt; 0) then /as:CAM/as:AssemblyStructure/as:Structure/@ID else /as:CAM/as:AssemblyStructure/as:Structure/as:Element/@name"/></xsl:param>
<xsl:param name="modifier"><xsl:value-of select="/as:CAM/as:Header/as:Owner"/></xsl:param>
<xsl:param name="date"><xsl:value-of select="translate(/as:CAM/as:Header/as:DateTime,'T:-','')"/></xsl:param>
<xsl:output indent="yes" method="html" doctype-public="-//W3C//DTD XHTML 1.0 Strict//EN" doctype-system="http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"/>
<xsl:include href="tiddlywiki_output.xsl"/>
<xsl:variable name="nbsp">&#160;&#160;</xsl:variable>
<xsl:variable name="version">1.02</xsl:variable>
<xsl:template match="/">
	<xsl:variable name="contents">
	<xsl:apply-templates select="//as:Header"/>
	<xsl:apply-templates select="//as:AssemblyStructure"/>
	</xsl:variable>

<xsl:call-template name="start">
<xsl:with-param name="contents" select="$contents"/>
<xsl:with-param name="root">[[<xsl:value-of select="as:CAM/as:AssemblyStructure/as:Structure/@ID"/>]]</xsl:with-param>
</xsl:call-template>

</xsl:template>


<xsl:template match="as:Header">
	<div title="CAM Header" modifier="{$modifier}" created="{$date}" changecount="1">
	   <pre>
<xsl:text>!</xsl:text>Template Name : <xsl:value-of select="$filename"/>

* Description: <xsl:value-of select="as:Description"/>
* Owner: <xsl:value-of select="as:Owner"/>
* Version: <xsl:value-of select="as:Version"/>
* Date: <xsl:value-of select="as:DateTime"/>

* Generator: <xsl:value-of select="$version"/>

For details of the Structure look at AssemblyStructure
	   </pre>

	</div>
</xsl:template>

<xsl:template match="as:AssemblyStructure">
	<div title="AssemblyStructure" modifier="{$modifier}" created="{$date}" changecount="1">
		<pre>
! Structures
		<xsl:for-each select="as:Structure">
* ID : [[<xsl:value-of select="@ID"/>]]
	</xsl:for-each>
		</pre>
	</div>
	<xsl:apply-templates select="as:Structure"/>
	<xsl:apply-templates select="//look:LookupList"/>
</xsl:template>

<xsl:template match="as:Structure">
	<div title="{@ID}" modifier="{$modifier}" created="{$date}" changecount="1">
		<pre>
		
|>| Click on the name of the element or attribute to view details. |
| @@color:green;font-family:webdings;q@@ | Rule exists. |
| @@color:purple;font-family:webdings;(@@ | Annotation exists |<xsl:text>

</xsl:text>
		<xsl:apply-templates select="as:Element" mode="source">
			<xsl:with-param name="indent">&#160;&#160;</xsl:with-param>
			<xsl:with-param name="included">false</xsl:with-param>
		</xsl:apply-templates>
		</pre>
	</div>
	<xsl:apply-templates select="//as:Element[@applyTemplate]" mode="applyTemplate"/>
	<xsl:apply-templates select="//as:Element[@includedFile]" mode="included"/>
	<xsl:apply-templates select="as:Element" />
</xsl:template>

<xsl:template match="as:Element" mode="applyTemplate">
	<div title="{@applyTemplate}" modifier="{$modifier}" created="{$date}" changecount="1">
		<pre>
		
|>| Click on the name of the element or attribute to view details. |
| @@color:green;font-family:webdings;q@@ | Rule exists. |
| @@color:purple;font-family:webdings;(@@ | Annotation exists |<xsl:text>

</xsl:text>
		<xsl:apply-templates select="." mode="source">
			<xsl:with-param name="indent">&#160;&#160;</xsl:with-param>
			<xsl:with-param name="included">true</xsl:with-param>
		</xsl:apply-templates>
		</pre>
	</div>
</xsl:template>

<xsl:template match="as:Element" mode="included">
	<div title="{@includedFile}" modifier="{$modifier}" created="{$date}" changecount="1">
		<pre>
		
|>| Click on the name of the element or attribute to view details. |
| @@color:green;font-family:webdings;q@@ | Rule exists. |
| @@color:purple;font-family:webdings;(@@ | Annotation exists |<xsl:text>

</xsl:text>
		<xsl:apply-templates select="." mode="source">
			<xsl:with-param name="indent">&#160;&#160;</xsl:with-param>
			<xsl:with-param name="included">true</xsl:with-param>
		</xsl:apply-templates>
		</pre>
	</div>
</xsl:template>


<xsl:template match="as:Element" mode="source">
<xsl:param name="indent" select="$nbsp"/>
<xsl:param name="included">false</xsl:param>
<xsl:choose>
<xsl:when test="@exampleValue and string-length(@exampleValue) > 0"><xsl:value-of select="$indent" disable-output-escaping="yes"/>@@color:red;font-family: courier;font-weight:bold;&lt;@@[[<xsl:value-of select="@name"/>]]<xsl:if test="as:Attribute"><xsl:text>
</xsl:text><xsl:apply-templates select="as:Attribute" mode="source"><xsl:with-param name="indent"><xsl:value-of select="$indent" disable-output-escaping="yes"/></xsl:with-param></xsl:apply-templates><xsl:value-of select="$indent" disable-output-escaping="yes"/><xsl:value-of select="$indent" disable-output-escaping="yes"/> @@color:red;font-family:courier;font-weight:bold;&gt;@@</xsl:if>"""<xsl:value-of select="@exampleValue"/>"""@@color:red;font-family: courier;font-weight:bold;&lt;@@/[[<xsl:value-of select="@name"/>]]@@color:red;font-family: courier;font-weight:bold;&gt;@@<xsl:if test="as:Rule">@@color:green;font-family:webdings;q@@</xsl:if><xsl:if test="camed:annotation">@@color:purple;font-family:webdings;(@@</xsl:if><xsl:text>
</xsl:text>
</xsl:when>
<xsl:otherwise>
<xsl:value-of  select="$indent" disable-output-escaping="yes"/>@@color:red;font-family:courier;font-weight:bold;&lt;@@[[<xsl:value-of select="@name"/>]]<xsl:if test="count(as:Attribute) &lt;1">@@color:red;font-family:courier;font-weight:bold;&gt;@@</xsl:if><xsl:if test="as:Rule">@@color:green;font-family:webdings;q@@</xsl:if><xsl:if test="camed:annotation">@@color:purple;font-family:webdings;(@@</xsl:if><xsl:if test="@applyTemplate and contains($included,'false')"><xsl:text>
</xsl:text><xsl:value-of select="$indent" disable-output-escaping="yes"/><xsl:value-of select="$indent" disable-output-escaping="yes"/>  @@background-color:#f7bdde;for rules and content see: [[<xsl:value-of select="@applyTemplate"/>]]@@</xsl:if><xsl:text>
</xsl:text>
<xsl:if test="not(@applyTemplate and contains($included,'false'))">
<xsl:choose>
<xsl:when test="@includedFile and $included='false'"><xsl:value-of select="$indent" disable-output-escaping="yes"/>  @@background-color:#debdde;following content included from: [[<xsl:value-of select="@includedFile"/>]]@@<xsl:text>
</xsl:text></xsl:when>
</xsl:choose> 
<xsl:variable name="attrCount"><xsl:value-of select="count(as:Attribute)"/></xsl:variable>
<xsl:apply-templates select="as:Attribute" mode="source"><xsl:with-param name="indent"><xsl:value-of select="$indent" disable-output-escaping="yes"/></xsl:with-param><xsl:with-param name="attrCount" select="$attrCount"/></xsl:apply-templates>
<xsl:apply-templates select="as:Element" mode="source">
<xsl:with-param name="indent"><xsl:value-of select="concat($indent,$nbsp)" disable-output-escaping="yes"/></xsl:with-param>
<xsl:with-param name="included">false</xsl:with-param>
</xsl:apply-templates>
</xsl:if>
<xsl:value-of select="$indent" disable-output-escaping="yes"/>@@color:red;font-family:courier;font-weight:bold;&lt;@@/[[<xsl:value-of select="@name"/>]]@@color:red;font-family:courier;font-weight:bold;&gt;@@
</xsl:otherwise>
</xsl:choose>

</xsl:template>

<xsl:template match="as:Attribute" mode="source">
<xsl:param name="indent" select="$nbsp"/>
<xsl:param name="attrCount"/>
 <xsl:variable name="attrCountValue">
   <xsl:choose>
    <xsl:when test="string-length($attrCount) &lt; 1"><xsl:value-of select="xs:integer(0)"/></xsl:when>
    <xsl:otherwise><xsl:value-of select="xs:integer($attrCount)"/></xsl:otherwise>
   </xsl:choose>
 </xsl:variable>
<xsl:value-of select="$indent" disable-output-escaping="yes"/><xsl:value-of select="$indent" disable-output-escaping="yes"/>[[@<xsl:value-of select="@name"/>]]=""""<xsl:value-of select="@exampleValue"/>""""<xsl:if test="$attrCountValue=position()">@@color:red;font-family:courier;font-weight:bold;&gt;@@</xsl:if><xsl:if test="as:Rule">@@color:green;font-family:webdings;q@@</xsl:if><xsl:if test="camed:annotation">@@color:purple;font-family:webdings;(@@</xsl:if><xsl:text>
</xsl:text>
</xsl:template>



<xsl:template match="as:Element">
<xsl:variable name="tags"><xsl:for-each select="as:Rule/as:constraint[count(@condition)=0]"><xsl:value-of select="substring-before(@action,'(')"/><xsl:text> </xsl:text></xsl:for-each><xsl:if test="as:Rule/as:constraint/@condition"> conditional</xsl:if></xsl:variable>
<xsl:element name="div">
 <xsl:attribute name="title"><xsl:value-of select="@name"/></xsl:attribute>
 <xsl:attribute name="modifier"><xsl:value-of select="$modifier"/></xsl:attribute>
 <xsl:attribute name="date"><xsl:value-of select="$date"/></xsl:attribute>
 <xsl:attribute name="changecount"><xsl:value-of select="1"/></xsl:attribute>
<xsl:if test="string-length($tags) &gt; 1">
 <xsl:attribute name="tags"><xsl:value-of select="$tags"/></xsl:attribute>
</xsl:if>
<pre>
<xsl:if test="camed:annotation">
<htmlz>
<table border="1">
<xsl:for-each select="camed:annotation/camed:documentation">
<tr><td><xsl:value-of select="@type"/></td><td><xsl:value-of select="."/></td></tr>
</xsl:for-each>
</table>
</htmlz>
</xsl:if>
<xsl:if test="as:Rule">
<htmlz>
<table border="1">
<xsl:for-each select="as:Rule/as:constraint">
<tr>
	<td> 
	<xsl:choose>
	<xsl:when test="starts-with(@action,'lookup')">
		<xsl:value-of select="substring-before(@action,'(')"/>( <a href="#{substring-before(substring-after(@action,'lookup('),')')}"><b><xsl:value-of select="substring-before(substring-after(@action,'lookup('),')')"/></b></a> )</xsl:when>
	<xsl:otherwise>	<xsl:value-of select="@action"/> </xsl:otherwise>
	</xsl:choose>
	</td>
	<td> <xsl:value-of select="@condition"/> </td>
		<xsl:choose>
			<xsl:when test="as:annotation">
				<xsl:for-each select="as:annotation/as:documentation">
					<td>''<xsl:value-of select="@type"/>'' :<xsl:value-of select="."/></td>
				</xsl:for-each>
			</xsl:when>
		</xsl:choose>
	</tr></xsl:for-each>
</table>
</htmlz>
</xsl:if>
</pre>
</xsl:element>
<xsl:apply-templates select="as:Attribute"/>
<xsl:apply-templates select="as:Element"/>
</xsl:template>

<xsl:template match="as:Attribute">
<xsl:variable name="tags"><xsl:for-each select="as:Rule/as:constraint[count(@condition)=0]"><xsl:value-of select="substring-before(@action,'(')"/><xsl:text> </xsl:text></xsl:for-each><xsl:if test="as:Rule/as:constraint/@condition"> conditional</xsl:if></xsl:variable>
<xsl:element name="div">
 <xsl:attribute name="title">@<xsl:value-of select="@name"/></xsl:attribute>
 <xsl:attribute name="modifier"><xsl:value-of select="$modifier"/></xsl:attribute>
 <xsl:attribute name="date"><xsl:value-of select="$date"/></xsl:attribute>
 <xsl:attribute name="changecount"><xsl:value-of select="1"/></xsl:attribute>
<xsl:if test="string-length($tags) &gt; 1">
 <xsl:attribute name="tags"><xsl:value-of select="$tags"/></xsl:attribute>
</xsl:if>
<pre>
<xsl:if test="camed:annotation">
<htmlz>
<table border="1">
<xsl:for-each select="camed:annotation/camed:documentation">
<tr><td><xsl:value-of select="@type"/></td><td><xsl:value-of select="."/></td></tr>
</xsl:for-each>
</table>
</htmlz>
</xsl:if>
<xsl:if test="as:Rule">
<htmlz>
<table border="1">
<xsl:for-each select="as:Rule/as:constraint">
<tr>
	<td> 
	<xsl:choose>
	<xsl:when test="starts-with(@action,'lookup')">
		<xsl:value-of select="substring-before(@action,'(')"/>( <a href="#{substring-before(substring-after(@action,'lookup('),')')}"><b><xsl:value-of select="substring-before(substring-after(@action,'lookup('),')')"/></b></a> )</xsl:when>
	<xsl:otherwise>	<xsl:value-of select="@action"/> </xsl:otherwise>
	</xsl:choose>
	</td>
	<td><xsl:value-of select="@condition"/></td>
	<xsl:if test="as:annotation/as:documentation">
	<tr>
		<xsl:for-each select="as:annotation/as:documentation">
			<td><xsl:value-of select="@type"/></td>
			<td><xsl:value-of select="."/></td>
		</xsl:for-each>
	</tr>
	</xsl:if>
</tr>
</xsl:for-each>
</table>
</htmlz>
</xsl:if>
</pre>
</xsl:element>
</xsl:template>


<xsl:template match="look:LookupList">
<xsl:element name="div">
 <xsl:attribute name="title"><xsl:value-of select="@name"/></xsl:attribute>
 <xsl:attribute name="modifier"><xsl:value-of select="$modifier"/></xsl:attribute>
 <xsl:attribute name="date"><xsl:value-of select="$date"/></xsl:attribute>
 <xsl:attribute name="changecount"><xsl:value-of select="1"/></xsl:attribute>
 <pre>
<htmlz>
<table border="1">
<tr><th>Name</th><th>Value</th></tr>
<xsl:for-each select="look:item">
<tr><td><xsl:value-of select="@name"/></td><td><xsl:value-of select="."/></td></tr>
</xsl:for-each>
</table>

</htmlz>
 </pre>
</xsl:element>	
</xsl:template>


</xsl:stylesheet><!-- Stylus Studio meta-information - (c) 2004-2007. Progress Software Corporation. All rights reserved.
<metaInformation>
<scenarios ><scenario default="yes" name="Scenario1" userelativepaths="yes" externalpreview="no" url="file:///c:/eclipse3.2/eclipse/temp.xml" htmlbaseurl="" outputurl="" processortype="saxon8" useresolver="no" profilemode="0" profiledepth="" profilelength="" urlprofilexml="" commandline="" additionalpath="" additionalclasspath="" postprocessortype="none" postprocesscommandline="" postprocessadditionalpath="" postprocessgeneratedext="" validateoutput="no" validator="internal" customvalidator="" ><advancedProp name="sInitialMode" value=""/><advancedProp name="bXsltOneIsOkay" value="true"/><advancedProp name="bSchemaAware" value="false"/><advancedProp name="bXml11" value="false"/><advancedProp name="iValidation" value="0"/><advancedProp name="bExtensions" value="true"/><advancedProp name="iWhitespace" value="0"/><advancedProp name="sInitialTemplate" value=""/><advancedProp name="bTinyTree" value="false"/><advancedProp name="bWarnings" value="true"/><advancedProp name="bUseDTD" value="false"/><advancedProp name="iErrorHandling" value="0"/></scenario></scenarios><MapperMetaTag><MapperInfo srcSchemaPathIsRelative="yes" srcSchemaInterpretAsXML="no" destSchemaPath="" destSchemaRoot="" destSchemaPathIsRelative="yes" destSchemaInterpretAsXML="no"/><MapperBlockPosition></MapperBlockPosition><TemplateContext></TemplateContext><MapperFilter side="source"></MapperFilter></MapperMetaTag>
</metaInformation>
-->